import Flutter
import UIKit

public class SwiftFlutterVerifaiPlugin: NSObject, FlutterPlugin, VerifaiViewControllerDelegate {

  private var result: FlutterResult?
  private var hostViewController: UIViewController?

  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "flutter_verifai", binaryMessenger: registrar.messenger())
    let instance = SwiftFlutterVerifaiPlugin()
    instance.hostViewController = UIApplication.shared.delegate?.window??.rootViewController
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    print("method called")
    self.result = result
    let verifaiViewController = VerifaiViewController()
    let navigationController = UINavigationController(rootViewController: verifaiViewController)
    guard let args = call.arguments else {
          result("iOS could not recognize flutter arguments in method: (sendParams)");
          return
        }
        if let myArgs = args as? [String: Any],
          let licence = myArgs["licence"] as? String {
             NSLog(licence)
             verifaiViewController.licenceString = licence
             verifaiViewController.delegate = self
             hostViewController?.present(navigationController, animated: false)
          } else {
            result(FlutterError(code: "-1", message: "iOS could not extract " +
             "flutter arguments in method: (sendParams)", details: nil));
        }
  }

  func verifaiResultFailed(_ controller: VerifaiViewController?, error: String) {
      result?(FlutterError(code: "verifaiResultFailed", message: error, details: nil));
      return;
    }

  func verifaiResultSuccess(_ controller: VerifaiViewController?, scanResult: Dictionary<String, String?>) {
    result?(scanResult);
    return;
  }
}
